local require = require

local pstat = require("posix.sys.stat")

local stat = pstat.stat
local tostring = tostring
local io_open = io.open
local io_lines = io.lines
local execute = os.execute
local format = string.format

local mt = {}

local outSyms = "/tmp/elfsym"

local function fileSize(path)
    local res = stat(path)
    if res then
        return res.st_size
    end
    return 0
end

function mt.getElfs(pid, elf)
    if elf == "/proc/kallsyms" then
        local f = io_open(outSyms, "w")
        if f then
            local size = 0
            for line in io_lines("/proc/kallsyms") do
                if size > 0 then
                    f:write("\n")
                    size = size + 1
                end
                f:write(line)
                size = size + #line
            end
            f:close()
            return tostring(size)
        else
            return "-1"
        end
    else
        local cmd = format("../native/dumpSym %s %s", pid, elf)
        local r = execute(cmd)
        if r == 0 then
            return tostring(fileSize(outSyms))
        else
            return "-1"
        end
    end
end

return mt